package TableOfContents::Tags;
use strict;

sub hdlr_table_of_contents {
    my ($ctx, $args) = @_;

    my $blog = $ctx->stash('blog');

    my $cfg = $ctx->{config};
    my $static_path  = $cfg->StaticWebPath;
    if ( !$static_path ) {
        $static_path = $cfg->CGIPath;
        $static_path .= '/' unless $static_path =~ m!/$!;
        $static_path .= 'mt-static/';
    }
    if ( $static_path =~ m!^/! ) {

        # relative path, prepend blog domain
        if ($blog) {
            my ($blog_domain) = $blog->archive_url =~ m|(.+://[^/]+)|;
            $static_path = $blog_domain . $static_path;
        }
    }
    $static_path .= '/' unless $static_path =~ m!/$!;

    my $plugin = MT->component('TableOfContents');
    my $toc_target = $plugin->get_config_value('toc_target', 'blog:' . $blog->id);
    my $start_level = $plugin->get_config_value('start_level', 'blog:' . $blog->id);

    return <<EOF;
<link rel="stylesheet" href="${static_path}plugins/TableOfContents/css/styles.css" type="text/css" title="TOC" media="screen,tv" />
<script src="${static_path}plugins/TableOfContents/js/jquery.toc.js"></script>
<script>
\$(function(){
    var div = \$('<div id="toc"></div>');
    \$("$toc_target").prepend(div);
    \$("$toc_target").toc({
        startLevel: "$start_level"
    });
});
</script>
EOF

}

1;